# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import usermsg
import gamethread
import cmdlib
import random
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
blindtag     = '#greenBLIND'
blind_hudtag = 'BLIND'

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def load():
	### Create Vars ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_blind_%s' % ply.steamid)
		var.set(0)

	### CMDs ###
	cmdlib.registerSayCommand('!blind', blindCMD,'SAM')
	cmdlib.registerSayCommand('!sam_blind', blindCMD,'SAM')
	cmdlib.registerSayCommand('!unblind', unblindCMD,'SAM')
	cmdlib.registerSayCommand('!sam_unblind', unblindCMD,'SAM')

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### Unblind Players ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_blind_%s' % ply.steamid)) == 1: unblind(ply)

	### Unreg ###
	cmdlib.unregisterSayCommand('!blind')
	cmdlib.unregisterSayCommand('!sam_blind')
	cmdlib.unregisterSayCommand('!unblind')
	cmdlib.unregisterSayCommand('!sam_unblind')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def blindCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Blind'):
			if args:
				try: moduleAction(userid, playerlib.getPlayer(es.getuserid(args[0])), 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), blind_hudtag)
			else: block.function(userid, 'Blind', None)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unblindCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Blind'):
			if args:
				try:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if int(es.ServerVar('sam_blind_%s' % target.steamid)) == 1: moduleAction(userid, target, 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), blind_hudtag)
			else: block.function(userid, 'Blind', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, menu=0):
	if int(es.ServerVar('sam_blind_%s' % target.steamid)) != 1:
		blind(target)
		func.tell('#all', func.lang_pcontrol('blind_target_blinded', {'target':target.name}), blindtag)
	else:
		unblind(target)
		func.tell('#all', func.lang_pcontrol('blind_target_unblinded', {'target':target.name}), blindtag)
	if menu == 0: block.function(userid, 'Blind', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def blind(target):
	targetvar = es.ServerVar('sam_blind_%s' % target.steamid)
	targetvar.set(1)
	usermsg.fade(target, 2, 1, 100, 0, 0, 0)
	gamethread.delayedname(.01, 'sam_blind_%s' % target, blind, (target))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unblind(target):
	targetvar = es.ServerVar('sam_blind_%s' % target.steamid)
	targetvar.set(0)
	gamethread.cancelDelayed('sam_blind_%s' % target)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_blind_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_godmode_%s' % ply.steamid)
		var.set(0)
		unblind(ply)

# ============================================================================================================================================================== #