# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES

filters = {'#all':'#alive','#alive':'#alive','#ct':'#ct','#t':'#t'}
freezetag     = '#greenFREEZE'
freeze_hudtag = 'FREEZE'

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_freeze_%s' % ply.steamid)
		var.set(0)

	cmdlib.registerSayCommand('!freeze', freezeCMD,'SAM')
	cmdlib.registerSayCommand('!sam_freeze', freezeCMD,'SAM')
	cmdlib.registerSayCommand('!unfreeze', unfreezeCMD,'SAM')
	cmdlib.registerSayCommand('!sam_unfreeze', unfreezeCMD,'SAM')

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### UNCLIP PLAYERS ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_freeze_%s' % ply.steamid)) == 1: unfreeze(ply)

	cmdlib.unregisterSayCommand('!freeze')
	cmdlib.unregisterSayCommand('!sam_freeze')
	cmdlib.unregisterSayCommand('!unfreeze')
	cmdlib.unregisterSayCommand('!sam_unfreeze')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def freezeCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Freeze'):
			if args:
				if not args[0] in filters:
					try: moduleAction(admin, playerlib.getPlayer(es.getuserid(args[0])), 0, 1)
					except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), freeze_hudtag)
				else:
					list = playerlib.getPlayerList(filters[args[0]])
					for ply in list:
						if admins.checkImmunity(es.getplayersteamid(userid), ply.steamid, 0) and int(es.ServerVar('sam_freeze_%s' % ply.steamid)) == 0: moduleAction(admin, ply, 1, 1)
						else: list.remove(ply)
					if len(list) > 0: func.tell('#all', func.lang_pcontrol('freeze_multi_targets', {'num':len(list)}), freezetag)
			else: block.function(userid, 'Freeze', None)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unfreezeCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Freeze'):
			if args:
				if not args[0] in filters:
					try:
						target = playerlib.getPlayer(es.getuserid(args[0]))
						if int(es.ServerVar('sam_freeze_%s' % target.steamid)) == 1: moduleAction(admin, target, 0, 1)
					except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), freeze_hudtag)
				else:
					list = playerlib.getPlayerList(filters[args[0]])
					for ply in list:
						if admins.checkImmunity(es.getplayersteamid(userid), ply.steamid, 0) and int(es.ServerVar('sam_freeze_%s' % ply.steamid)) == 1: moduleAction(admin, ply, 1, 1)
						else: list.remove(ply)
					if len(list) > 0: func.tell('#all', func.lang_pcontrol('unfreeze_multi_targets', {'num':len(list)}), freezetag)
			else: block.function(userid, 'Freeze', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, cmd=0, menu=0):
	targetvar = es.ServerVar('sam_freeze_%s' % target.steamid)
	if int(targetvar) != 1:
		freeze(target)
		if cmd == 0: func.tell('#all', func.lang_pcontrol('freeze_target_freezed', {'target':target.name}), freezetag)
	else:
		unfreeze(target)
		if cmd == 0: func.tell('#all', func.lang_pcontrol('freeze_target_unfreezed', {'target':target.name}), freezetag)
	if menu == 0: block.function(userid, 'Freeze', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def freeze(target):
	targetvar = es.ServerVar('sam_freeze_%s' % target.steamid)
	targetvar.set(1)
	target.freeze(1)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unfreeze(target):
	targetvar = es.ServerVar('sam_freeze_%s' % target.steamid)
	targetvar.set(0)
	target.freeze(0)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_freeze_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_freeze_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #